/*
* @par License info
*
*
* Copyright (C) 2016 Carlos Fernández Moraga
*
* This program is free software: you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation, either version 3 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program.  If not, see <http://www.gnu.org/licenses/>.
*
* This is free software, and you are welcome to redistribute it.
*
*/

package es.promax.inicio;

import android.app.Activity;
import android.content.Intent;
import android.os.Bundle;
import android.os.Handler;

import es.promax.promaxbt.R;

public class PantallaInicioActivity extends Activity {

    private static final int TIEMPO_ESPERA = 5; //Milisegundos

    @Override
	protected void onCreate(Bundle savedInstanceState) {
		// TODO Auto-generated method stub
		super.onCreate(savedInstanceState);
		//-------
        setContentView(R.layout.activity_inicio);
        //------        
	}
	
    @Override
	public  void onStart() {
    super.onStart();
    
    tiempoEspera(TIEMPO_ESPERA);

    }

    /**
     * Espera y cierra la aplicación tras los milisegundos indicados
     * @param milisegundos
     */
    public void tiempoEspera(int milisegundos) {
        Handler handler = new Handler();
        handler.postDelayed(new Runnable() {
            @Override
			public void run() {
                // acciones que se ejecutan tras los milisegundos
                finalizarApp();
            }
        }, milisegundos);
    }
 
    /**
     * Finaliza la aplicación
     */
    public void finalizarApp() {
		// TODO Auto-generated method stub

		Intent i = new Intent();

		setResult(RESULT_OK, i);

		finish();

    }


}
