/*
* @par License info
*
*
* Copyright (C) 2016 Carlos Fernández Moraga
*
* This program is free software: you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation, either version 3 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program.  If not, see <http://www.gnu.org/licenses/>.
*
* This is free software, and you are welcome to redistribute it.
*
*/

package es.promax.pantallas;

import android.app.Activity;
import android.content.Intent;
import android.os.Bundle;
import android.view.View;
import android.widget.Button;

import es.promax.inicio.PantallaInicioActivity;
import es.promax.promaxbt.R;

/**
 * Created by carlos on 12/11/15.
 */
public class ActivityPanantallaMenu extends Activity {

    public static final int REQUEST_INICIO_PANTALLA = 109;
    private Button scan, contellation;
    private Button spect;
    private Boolean inicioAplicacionPromax12 = true;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        // TODO Auto-generated method stub
        super.onCreate(savedInstanceState);

        //-------
        setContentView(R.layout.activity_menu);

        scan = (Button) findViewById(R.id.buttonSCAN);
        spect = (Button) findViewById(R.id.buttonSPECTRUM);
        contellation = (Button) findViewById(R.id.buttonCONSTELACION);


        scan.setOnClickListener(new View.OnClickListener() {
            public void onClick(View arg0) {
                Intent intent = new Intent(ActivityPanantallaMenu.this, ActivityPantallaScan.class);
                startActivityForResult(intent, REQUEST_INICIO_PANTALLA);
            }
        });

        spect.setOnClickListener(new View.OnClickListener() {
            public void onClick(View arg0) {
                Intent intent = new Intent(ActivityPanantallaMenu.this, ActivityPantallaSpectrum.class);
                startActivityForResult(intent, REQUEST_INICIO_PANTALLA);
            }
        });

        contellation.setOnClickListener(new View.OnClickListener() {
            public void onClick(View arg0) {
                Intent intent = new Intent(ActivityPanantallaMenu.this, ActivityPantallaContelacion.class);
                startActivityForResult(intent, REQUEST_INICIO_PANTALLA);
            }
        });
        //------
    }

    private void inicioPantallaPresentacion() {
        Intent intent = new Intent(ActivityPanantallaMenu.this, PantallaInicioActivity.class);
        startActivityForResult(intent, REQUEST_INICIO_PANTALLA);
    }

}
