/*
* @par License info
*
*
* Copyright (C) 2016 Carlos Fernández Moraga
*
* This program is free software: you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation, either version 3 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program.  If not, see <http://www.gnu.org/licenses/>.
*
* This is free software, and you are welcome to redistribute it.
*
*/
package es.promax.promaxbt;

import android.content.Context;
import android.graphics.Canvas;
import android.graphics.Color;
import android.graphics.DashPathEffect;
import android.graphics.Paint;
import android.graphics.Paint.Style;
import android.graphics.Path;
import android.graphics.Point;
import android.graphics.Rect;
import android.util.AttributeSet;
import android.util.Log;
import android.view.View;

import java.util.ArrayList;
import java.util.Locale;


public class DibujarLienzo extends View {
	

	private int width;
	private int height;
	
	private int  DIM_CELLA_X = 20;
	private int  DIM_CELLA_Y = 20;
	private int  DIMX = 6;
	private int  DIMY= 9;
	private int  POSX =100;
	private int  POSY =0;
	private float testTextSize = 48f;
	private int distanciaMinimaX=10;
	
	private int  POSX_BATTERY =100;
	private int  POSY_BATTERY =0;

	private Rect rectGrafica = null;
	private Rect rectBattery = null;
	private Rect rectReferenLevel = null;
	private Rect rectSpan = null;
	
	private boolean pintaLineaFrequency=false;
	private int lineFrequencyX=0;

	private Paint paintLineas = new Paint();
	private Paint paintLineasPX = new Paint();
	private Paint paintCuadrados = new Paint();
	private Paint paintTextCuadrado = new Paint();
	private Paint paintCursor = new Paint();
	private float textSizeCuadrado = 48f;



    private float cuadradoWidthX0;
    private float cuadradoWidth;
    private float cuadradoHeight;
    private float cuadradoHeightX0;

	
    private Point puntoInicio1;
    private Point puntoFin1;
    private Point puntoInicio2;
    private Point puntoFin2;
	private Point puntoMarker;

	private float partH;
    private float partW;
    
	
    private Promax12 px12;


	public DibujarLienzo(Context context, AttributeSet attrs, Promax12 promax12) {
		super(context, attrs);
		this.px12 = promax12;
		puntoMarker = new Point(55, 55);
	}

	public DibujarLienzo(Context context, Promax12 promax12) {
		super(context);
		this.px12 = promax12;
		puntoMarker = new Point(55, 55);
	}

@Override
protected void onSizeChanged(int w, int h, int oldw, int oldh) {
    width = w ;
    height = h ;

    super.onSizeChanged(w, h, oldw, oldh);
 }

private void RedimensionarSize() {

    //Escala
    DIM_CELLA_Y = height /(DIMY+3);	//JCB
    DIM_CELLA_X = width /(DIMX+2);	//JCB
	DIM_CELLA_Y = Math.min(DIM_CELLA_X,DIM_CELLA_Y);	//JCB
    DIM_CELLA_X = DIM_CELLA_Y;
    testTextSize = (float) (DIM_CELLA_Y/1.75);
    float escala = getResources().getDisplayMetrics().density;
	textSizeCuadrado = escala * 26;

    Log.d("TAG", "Escala " + escala);

    POSX = (width - (DIMX * DIM_CELLA_X ) )/ 2;


	POSX_BATTERY =(width - (2 * DIM_CELLA_X ) );
	POSY_BATTERY = DIM_CELLA_Y*10;

	//rect = new Rect(0, 0, getWidth(), getHeight());
	rectBattery = new Rect((POSX_BATTERY), POSY_BATTERY+DIM_CELLA_Y, width,POSY_BATTERY+DIM_CELLA_Y + DIM_CELLA_Y);


	this.setDistanciaMinimaX((int) (width * 0.1));

	////--Promax 12

	cuadradoWidthX0 = (int) (width * 0.05);
	cuadradoWidth = (int) (width * 0.95);
	cuadradoHeight = (int) (height*0.9);
	cuadradoHeightX0 = (int) (height*0.1);

	partH = cuadradoHeight / 4;
	partW = cuadradoWidth / 10;

    setRectGrafica(new Rect((int) cuadradoWidthX0, 0, width, (int) cuadradoHeight));
    setRectReferenLevel(new Rect(0, 0, (int) cuadradoWidthX0, height));


    setRectSpan(new Rect((int) cuadradoWidthX0, (int) (height - cuadradoHeightX0), width, height));
    //private Rect rectSpan;

	//POSY =height;
	Log.d("TAG", "onSizeChanged: width " + width + ", height " + height);


}

@Override
protected void onDraw(Canvas canvas) {  
	super.onDraw(canvas);

	canvas.drawColor(Color.BLACK);
	RedimensionarSize();
	
	pintaEjes(canvas);
	pintaFrequencies(canvas);
	
	if(isPintaLineaFrequency()){
		PintaLineaFrequency(canvas);
	}


	pintaCursor(canvas);
	if(px12.getInicializadoPromax12()){
		
		
		
		if(px12.getValoresPromax12()!=null){
			
			
	  	      switch (px12.getPantalla()) {


				  case MainActivity.MENSAJE_RECIBIDO_MESURA_SPECTRUM:
					  pintaMesuraPX_Spectrum(canvas);
					  break;

				  case MainActivity.MENSAJE_RECIBIDO_MESURA_SCAN:
					  pintaMesuraPX_Scan(canvas);
	             break;
	  	      }
		}
		

	}
	
}

private void pintaEjes(Canvas canvas){

    setRectGrafica(new Rect((int) cuadradoWidthX0, 0, width, (int) cuadradoHeight));
    setRectReferenLevel(new Rect(0, 0, (int) cuadradoWidthX0, height));
    setRectSpan(new Rect((int) cuadradoWidthX0, (int) (height - cuadradoHeightX0), width, height));
    //private Rect rectSpan;



	paintCuadrados.setAntiAlias(true);
	paintCuadrados.setStyle(Style.STROKE);
	paintCuadrados.setStrokeWidth(5);
	paintCuadrados.setTextSize(testTextSize);


	paintLineas.setColor(Color.WHITE);
	paintLineas.setStrokeWidth(1);
	paintLineas.setStyle(Paint.Style.STROKE);


	paintTextCuadrado.setAntiAlias(true);
	paintTextCuadrado.setStrokeWidth(1);
	paintTextCuadrado.setTextSize(textSizeCuadrado);


	paintTextCuadrado.setColor(Color.WHITE);


	//lineas de puntos
	Path path = new Path();

 
    //Horizontal line --------------------------------
	for (int i = 0; i < 5; i++) {

		path.moveTo(cuadradoWidthX0, (i * partH));
		path.lineTo(width, (i * partH));
		//canvas.drawLine( cuadradoWidthX0 , (i * partH), width, (i * partH), paintLineas);

		paintTextCuadrado.setTextAlign(Paint.Align.CENTER);

		float posticionTextY = 0;
		if (i < 1) {
			posticionTextY = (i * partH) + paintTextCuadrado.getTextSize();
		} else {
			posticionTextY = (i * partH) + paintTextCuadrado.getTextSize() / 2;
		}

		canvas.drawText(Integer.toString(((4 + px12.getReferenLevel()) * 10) - (i * 10)), getRectReferenLevel().centerX(), posticionTextY, paintTextCuadrado);
	}

    //Vertical line -----------------------------

	for (int i = 0; i < 11; i++) {
		path.moveTo(cuadradoWidthX0 + (i * partW), 0);
		path.lineTo(cuadradoWidthX0 + (i * partW), cuadradoHeight);
	}

	float[] intervals = new float[]{1.0f, 5.0f};
	float phase = 0;

	DashPathEffect dashPathEffect =
			new DashPathEffect(intervals, phase);

	paintLineas.setPathEffect(dashPathEffect);


	canvas.drawPath(path, paintLineas);

}

	private void pintaCursor(Canvas canvas) {

		paintCursor.setColor(Color.BLUE);
		paintCursor.setStrokeWidth(2);
		paintCursor.setStyle(Paint.Style.STROKE);
		//lineas de puntos
		Path path = new Path();

		float size = 10;
		float x = puntoMarker.x + (size / 2);
		float y = puntoMarker.y;


		path.moveTo(x, y);
		path.lineTo(x + size, y - size);
		path.lineTo(x - size, y - size);
		path.lineTo(x, y);

		canvas.drawPath(path, paintCursor);
	}


private void pintaFrequencies(Canvas canvas){
	
	int span = px12.getSpam();
	int frequency;
	int offset=0;
	
	frequency = px12.getFrequencyKhz();
	
    switch (span) {
      
	    case 0:
	    	offset=5000;
            px12.setFrequencyKhzMax(frequency + offset);
            px12.setFrequencyKhzMim(frequency - offset);
            break;
        case 1:
	    	offset=2500;
            px12.setFrequencyKhzMax(frequency + offset);
            px12.setFrequencyKhzMim(frequency - offset);
            break;
        case 2:
	    	offset=1500;
            px12.setFrequencyKhzMax(frequency + offset);
            px12.setFrequencyKhzMim(frequency - offset);
            break;
        case 3:
	    	offset=750;
            px12.setFrequencyKhzMax(frequency + offset);
            px12.setFrequencyKhzMim(frequency - offset);
            break;
        case 4:
	    	offset=250;
            px12.setFrequencyKhzMax(frequency + offset);
            px12.setFrequencyKhzMim(frequency - offset);
            break;
        case 5:
	    	offset=50;
            px12.setFrequencyKhzMax(frequency + offset);
            px12.setFrequencyKhzMim(frequency - offset);
            break;

        default:
	    	offset=0;
            px12.setFrequencyKhzMax(Promax12.FREQUENCY_MAX);
            px12.setFrequencyKhzMim(Promax12.FREQUENCY_MIN);
            break;
    }

    if (px12.getFrequencyKhzMax() > Promax12.FREQUENCY_MAX) {
        px12.setFrequencyKhzMax(Promax12.FREQUENCY_MAX);
        px12.setFrequencyKhzMim(Promax12.FREQUENCY_MAX - offset);
    }

    if (px12.getFrequencyKhzMim() < Promax12.FREQUENCY_MIN) {
        px12.setFrequencyKhzMax(Promax12.FREQUENCY_MIN + offset);
        px12.setFrequencyKhzMim(Promax12.FREQUENCY_MIN);
    }


	String s_frequencyMax = (String.format(Locale.ENGLISH, "%.2f", ((double) px12.getFrequencyKhzMax() / 100.00)) + " MHz");
	String s_frequencyMin = (String.format(Locale.ENGLISH, "%.2f", ((double) px12.getFrequencyKhzMim() / 100.00)) + " MHz");
	//String s_frequency = (String.format(Locale.ENGLISH, "%.2f", ((double) frequency / 100.00)) + " MHz");


	float centerCuadratY = getRectSpan().bottom - ((getRectSpan().bottom - getRectSpan().centerY()) / 2);

	paintTextCuadrado.setTextAlign(Paint.Align.CENTER);
	canvas.drawText(px12.getStringSpam(), getRectSpan().centerX(), centerCuadratY, paintTextCuadrado);

	paintTextCuadrado.setTextAlign(Paint.Align.RIGHT);
	canvas.drawText(s_frequencyMax, getRectSpan().right, centerCuadratY, paintTextCuadrado);

	paintTextCuadrado.setTextAlign(Paint.Align.LEFT);
	canvas.drawText(s_frequencyMin, getRectSpan().left, centerCuadratY, paintTextCuadrado);
	
}


	private void pintaMesuraPX_Scan(Canvas canvas) {

	int[] valoresP12;
		int anchuraDelLapiz = 3;
	ArrayList<Point> puntosToPain = new ArrayList<Point>();
	valoresP12=px12.getValoresPromax12();

	paintLineasPX.setAntiAlias(true);
	paintLineasPX.setStyle(Style.STROKE);
		paintLineasPX.setStrokeWidth(anchuraDelLapiz);
		paintLineasPX.setColor(Color.GREEN);
	paintLineasPX.setTextSize(testTextSize);
	
	for(int i=0; i<=110;i++)
	{
        float x = cuadradoWidthX0 + (cuadradoWidth / 110.00f) * px12.calculoRecta(i);
        float y = (((valoresP12[i] - ((1 + px12.getReferenLevel()) * 100)) * cuadradoHeight) / 400);
        if (y > cuadradoHeight) {
            y= cuadradoHeight;
		}
		if (y<0){
			y= 0;
			valoresP12[i]=0;
		}
		if (px12.getPositionMarker() == i) {
			puntoMarker = new Point((int) x + (anchuraDelLapiz - 1), (int) (cuadradoHeight - y));
		}
		puntosToPain.add(new Point((int) x, (int) y));
    }

		for (int i = 1; i <= 110; i++) {
		if(valoresP12[i]!=0 || valoresP12[i-1]!=0){
            canvas.drawLine(puntosToPain.get(i).x, (cuadradoHeight - puntosToPain.get(i - 1).y), puntosToPain.get(i).x, (cuadradoHeight), paintLineasPX);
		}
		}
	puntosToPain.clear();   
}

	private void pintaMesuraPX_Spectrum(Canvas canvas) {
		int[] valoresP12;
		int anchuraDelLapiz = 3;
		ArrayList<Point> puntosToPain = new ArrayList<Point>();
		valoresP12 = px12.getValoresPromax12();

		paintLineasPX.setAntiAlias(true);
		paintLineasPX.setStyle(Style.STROKE);
		paintLineasPX.setStrokeWidth(anchuraDelLapiz);
		paintLineasPX.setColor(Color.GREEN);
		paintLineasPX.setTextSize(testTextSize);

		for (int i = 0; i <= 110; i++) {
			float x = cuadradoWidthX0 + (i * cuadradoWidth) / 110;
			float y = (((valoresP12[i] - ((1 + px12.getReferenLevel()) * 100)) * cuadradoHeight) / 400);
			if (y > cuadradoHeight) {
				y = cuadradoHeight;
			}
			if (y < 0) {
				y = 0;
				valoresP12[i] = 0;
			}
			if (px12.getPositionMarker() == i) {
				puntoMarker = new Point((int) x + (anchuraDelLapiz - 1), (int) (cuadradoHeight - y));
			}
			puntosToPain.add(new Point((int) x, (int) y));
		}

		for (int i = 1; i <= 110; i++) {
			if (valoresP12[i] != 0 || valoresP12[i - 1] != 0) {
				canvas.drawLine(puntosToPain.get(i - 1).x, (cuadradoHeight - puntosToPain.get(i - 1).y), puntosToPain.get(i).x, (cuadradoHeight - puntosToPain.get(i).y), paintLineasPX);
			}
		}

		puntosToPain.clear();
	}


private void PintaLineaFrequency(Canvas canvas)
{
		Paint paintLineFrequency= new Paint();
		paintLineFrequency.setAntiAlias(true);
		paintLineFrequency.setStyle(Style.STROKE);
	paintLineFrequency.setStrokeWidth(1);
		paintLineFrequency.setColor(Color.RED);
	paintLineFrequency.setTextSize(32f);
		paintLineFrequency.setTextAlign(Paint.Align.CENTER);
		
	    canvas.drawLine(lineFrequencyX , cuadradoHeightX0, lineFrequencyX , height, paintLineFrequency); // Pending: redondear
	    
	    int newFrequency = getnewLineaFrequency();
		
		String	s_frequency =  ((newFrequency/100))+ "."+ (newFrequency%100) ;  //new String (incremento +" " +newFrecuency +" "+ diferencia);//

	canvas.drawText(s_frequency, lineFrequencyX, cuadradoHeightX0, paintLineFrequency);

}

public int getnewLineaFrequency()
{  	    
		int span = px12.getSpam();
		int frequencyMax = 0;
		int frequencyMim = 0;
		int frequency;
		int offset=0;
		
		frequency = px12.getFrequencyKhz();
		
		switch (span) {
	      
	    case 0:
	    	offset=5000;
	    	frequencyMax = frequency + offset ;
	    	frequencyMim = frequency - offset ;
	  	break;
	    case 1:
	    	offset=2500;
	    	frequencyMax = frequency + offset ;
	    	frequencyMim = frequency - offset ;
	  	break;
	    case 2:
	    	offset=1500;
	    	frequencyMax = frequency + offset ;
	    	frequencyMim = frequency - offset ;
	  	break;
	    case 3:
	    	offset=750;
	    	frequencyMax = frequency + offset ;
	    	frequencyMim = frequency - offset ;
	  	break;
	    case 4:
	    	offset=250;
	    	frequencyMax = frequency + offset ;
	    	frequencyMim = frequency - offset ;
	  	break;
	    case 5:
	    	offset=50;
	    	frequencyMax = frequency + offset ;
	    	frequencyMim = frequency - offset ;
	  	break;
	  	
	  	default:
	    	offset=50250;
	    	frequencyMax = Promax12.FREQUENCY_MAX ;
	    	frequencyMim = Promax12.FREQUENCY_MIN ;
	  	break;
    }
	    
	    float newFrecuency = lineFrequencyX - rectSpan.left;
	    
	    float diferencia =  rectSpan.right - rectSpan.left ; 
	    
	    float incremento = (offset*2)/diferencia;
	    
	    
	    newFrecuency*=incremento;
	    
	    newFrecuency+=frequencyMim;

	    if(newFrecuency>frequencyMax){
	    	newFrecuency = frequencyMax;
	    }
	    
	    if(newFrecuency<frequencyMim){
	    	newFrecuency=frequencyMim;
	    }

	    return (int) newFrecuency;

}

public Rect getRectGrafica() {
	return rectGrafica;
}

public void setRectGrafica(Rect rectGrafica) {
	this.rectGrafica = rectGrafica;
}

public Rect getRectReferenLevel() {
	return rectReferenLevel;
}

public void setRectReferenLevel(Rect rectReferenLevel) {
	this.rectReferenLevel = rectReferenLevel;
}

public Rect getRectSpan() {
	return rectSpan;
}

public void setRectSpan(Rect rect) {
	this.rectSpan = rect;
}

public boolean isPintaLineaFrequency() {
	return pintaLineaFrequency;
}

public void setPintaLineaFrequency(boolean pintaLineaFrequency,int postX) {
	this.pintaLineaFrequency = pintaLineaFrequency;
	this.lineFrequencyX=postX;
}

public int getDistanciaMinimaX() {
	return distanciaMinimaX;
}

public void setDistanciaMinimaX(int distanciaMinimaX) {
	this.distanciaMinimaX = distanciaMinimaX;
}

}