/*
* @par License info
*
*
* Copyright (C) 2016 Carlos Fernández Moraga
*
* This program is free software: you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation, either version 3 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program.  If not, see <http://www.gnu.org/licenses/>.
*
* This is free software, and you are welcome to redistribute it.
*
*/
package es.promax.promaxbt;

import android.util.Log;

import java.util.ArrayList;

import es.promax.canalizacion.Canalizacion;

public class Promax12 {
	

    public static final int FREQUENCY_MAX = 100500;
    public static final int FREQUENCY_MIN = 500;
	public static final int eCR_1_4 = 0;        /* DVB-S2 */
	public static final int eCR_1_3 = 1;        /* DVB-T2, DVB-S2 */
	public static final int eCR_2_5 = 2;        /* DVB-T2, DVB-S2 */
	public static final int eCR_1_2 = 3;        /* DVB-T, DVB-T2, DVB-S, ISDB-T */
	public static final int eCR_3_5 = 4;        /* DVB-T2, DVB-S2 */
	public static final int eCR_2_3 = 5;        /* DVB-T, DVB-T2, DVB-C2, DVB-S, ATSC, ISDB-T */
	public static final int eCR_3_4 = 6;        /* DVB-T, DVB-T2, DVB-C2, DVB-S, ISDB-T */
	public static final int eCR_4_5 = 7;        /* DVB-T2, DVB-C2, DVB-S, ISDB-T */
	public static final int eCR_5_6 = 8;        /* DVB-T, DVB-T2, DVB-C2, DVB-S, ISDB-T */
	public static final int eCR_6_7 = 9;       /* DVB-T, DVB-S, ISDB-T */
	public static final int eCR_7_8 = 10;        /* DVB-T, DVB-S, ISDB-T */
	public static final int eCR_8_9 = 11;        /* DVB-C2, DVB-S2 */
	public static final int eCR_9_10 = 12;       /* DVB-C2, DVB-S2 */
	public static final int eCONSTELLATION_BPSK = 0;       /* DVB-T2 */
	public static final int eCONSTELLATION_QPSK = 1;        /* DVB-T, DVB-T2, DVB-S, ISDB-T */
	public static final int eCONSTELLATION_DQPSK = 2;       /* ISDB-T */
	public static final int eCONSTELLATION_8PSK = 3;        /* DVB-S2 */
	public static final int eCONSTELLATION_16APSK = 4;      /* DVB-S2 *
	public static final int eCONSTELLATION_32APSK = 5;      /* DVB-S2 */
	public static final int eCONSTELLATION_16QAM = 6;       /* DVB-T, DVB-C, DVB-T2, DVB-C2, ISDB-T */
	public static final int eCONSTELLATION_32QAM = 7;       /* DVB-C */
	public static final int eCONSTELLATION_64QAM = 8;       /* DVB-T, DVB-C, DVB-T2, DVB-C2, ISDB-T */
	public static final int eCONSTELLATION_128QAM = 9;      /* DVB-C */
	public static final int eCONSTELLATION_256QAM = 10;      /* DVB-C, DVB-T2, DVB-C2 */
	public static final int eCONSTELLATION_1024QAM = 11;     /* DVB-C2 */


	/* enum to define the different code rate. */
	//public enum eCODE_RATE_TYPE{
	//	eCR_1_4,        /* DVB-S2 */
	//	eCR_1_3,        /* DVB-T2, DVB-S2 */
	//	eCR_2_5,        /* DVB-T2, DVB-S2 */
	//	eCR_1_2,        /* DVB-T, DVB-T2, DVB-S, ISDB-T */
	//	eCR_3_5,        /* DVB-T2, DVB-S2 */
	//	eCR_2_3,        /* DVB-T, DVB-T2, DVB-C2, DVB-S, ATSC, ISDB-T */
	//	eCR_3_4,        /* DVB-T, DVB-T2, DVB-C2, DVB-S, ISDB-T */
	//	eCR_4_5,        /* DVB-T2, DVB-C2, DVB-S, ISDB-T */
	//	eCR_5_6,        /* DVB-T, DVB-T2, DVB-C2, DVB-S, ISDB-T */
	//	eCR_6_7,        /* DVB-T, DVB-S, ISDB-T */
	//	eCR_7_8,        /* DVB-T, DVB-S, ISDB-T */
	//	eCR_8_9,        /* DVB-C2, DVB-S2 */
	//	eCR_9_10,       /* DVB-C2, DVB-S2 */
	//} ;
	public static final int eCONSTELLATION_4096QAM = 12;     /* DVB-C2 */
	public static final int eCONSTELLATION_8VSB = 13;        /* ATSC */
	public static final int eBW_1_7MHz = 17;   /* DVB-T2 */
	public static final int eBW_2MHz = 0;      /* DVB-T */
	public static final int eBW_5MHz = 5;      /* DVB-T, DVB-T2 */
	public static final int eBW_6MHz = 6;      /* DVB-T, DVB-T2, DVB-C2, ISDB-T, ATSC */
	public static final int eBW_7MHz = 7;      /* DVB-T, DVB-T2 */
	public static final int eBW_8MHz = 8;      /* DVB-T, DVB-T2 */
	public static final int eBW_10MHz = 10;    /* DVB-T2 */
	public static final int eGUARD_1_4 = 0;       /* DVB-T, ISDB-T */
	public static final int eGUARD_1_8 = 1;       /* DVB-T, ISDB-T */
	public static final int eGUARD_1_16 = 2;      /* DVB-T, ISDB-T */
	public static final int eGUARD_1_32 = 3;      /* DVB-T, ISDB-T */


	/* enum to define the different constellation types. */
	//public enum eCONSTELLATION_TYPE {
	//	eCONSTELLATION_BPSK,        /* DVB-T2 */
	//	eCONSTELLATION_QPSK,        /* DVB-T, DVB-T2, DVB-S, ISDB-T */
	//	eCONSTELLATION_DQPSK,       /* ISDB-T */
	//	eCONSTELLATION_8PSK,        /* DVB-S2 */
	//	eCONSTELLATION_16APSK,      /* DVB-S2 */
	//	eCONSTELLATION_32APSK,      /* DVB-S2 */
	//	eCONSTELLATION_16QAM,       /* DVB-T, DVB-C, DVB-T2, DVB-C2, ISDB-T */
	//	eCONSTELLATION_32QAM,       /* DVB-C */
	//	eCONSTELLATION_64QAM,       /* DVB-T, DVB-C, DVB-T2, DVB-C2, ISDB-T */
	//	eCONSTELLATION_128QAM,      /* DVB-C */
	//	eCONSTELLATION_256QAM,      /* DVB-C, DVB-T2, DVB-C2 */
	//	eCONSTELLATION_1024QAM,     /* DVB-C2 */
	//	eCONSTELLATION_4096QAM,     /* DVB-C2 */
	//	eCONSTELLATION_8VSB,        /* ATSC */
	//} ;
	public static final int eGUARD_1_64 = 7;      /* DVB-C2 */
	public static final int eGUARD_1_128 = 4;     /* DVB-T2, DVB-C2 */
	public static final int eGUARD_19_128 = 5;    /* DVB-T2 */
	public static final int eGUARD_19_256 = 6;    /* DVB-T2 */
	private Boolean llenarMensaje = false;
	private Boolean lecturaBloaquada = false;
	private Boolean inicializadoPromax12=false;
	private int spam=6;
	private int amplitud=2;
	private int referenLevel=2;
	private int mensajeTexto=0;
	private int frequencyKhz=45000;
    private int frequencyKhzMax = FREQUENCY_MAX;
    private int frequencyKhzMim = FREQUENCY_MIN;
    private String levelBatery;

	/* enum to define the different band width. */
	//public enum eBAND_WIDTH {
	//	eBW_1_7MHz = 17,   /* DVB-T2 */
	//	eBW_2MHz ,      /* DVB-T */
	//	eBW_5MHz = 5,      /* DVB-T, DVB-T2 */
	//	eBW_6MHz = 6,      /* DVB-T, DVB-T2, DVB-C2, ISDB-T, ATSC */
	//	eBW_7MHz = 7,      /* DVB-T, DVB-T2 */
	//	eBW_8MHz = 8,      /* DVB-T, DVB-T2 */
	//	eBW_10MHz = 10,    /* DVB-T2 */
	private String versionPromax12;
	private String mensajeBT ="";
	private int pantalla = MainActivity.MENSAJE_RECIBIDO_MESURA_SCAN;
	private int intervaloGuarda = 0;
	private int portadoras = 0;
	private int codeRate = 0;


	private int dBm = 0;
	private int positionMarker = 55;
	private int tipoModulaciónPortadoras = 0;

	/* enum to define the different guard interval. */
	//public enum eGUARD_INTERVAL {
	//	eGUARD_1_4 = 0,       /* DVB-T, ISDB-T */
	//	eGUARD_1_8 = 1,       /* DVB-T, ISDB-T */
	//	eGUARD_1_16 = 2,      /* DVB-T, ISDB-T */
	//	eGUARD_1_32 = 3,      /* DVB-T, ISDB-T */
	//	eGUARD_1_64 = 7,      /* DVB-C2 */
	//	eGUARD_1_128 = 4,     /* DVB-T2, DVB-C2 */
	//	eGUARD_19_128 = 5,    /* DVB-T2 */
	//	eGUARD_19_256 = 6,    /* DVB-T2 */
	//};
	private String preBer;
	private String postBer;
    private String mer;
    private ArrayList<Integer> listadoMensajes = new ArrayList<Integer>();
    private ArrayList<String> listadoStringMensajes = new ArrayList<String>();
    private ArrayList<String> listadoErrores = new ArrayList<String>();
	private int[] valoresPromax12 = new int[500];
	private int[][] arrayColisionesConstelacion = new int[257][257];
	private Canalizacion canalesCCIR;

    public Promax12() {
        canalesCCIR = new Canalizacion();
        inicializarArrayColisionesConstelacion();
        inicializarArrayPromax12();
        // TODO Auto-generated constructor stub
	}

	public int[][] getArrayColisionesConstelacion() {
		return arrayColisionesConstelacion;
	}
	
	public void mensajeRecibido(String mensaje) {
		
		int inicioString;
		int finString;
		
		
		mensajeBT+=mensaje;
		
		if (lecturaBloaquada==true){
			return;
		}
		
		do{
			inicioString = mensajeBT.indexOf('*');
			
			if(inicioString==-1){
				mensajeBT="";
				return;
			}else if(inicioString>0){
				mensajeBT =mensajeBT.substring(inicioString,mensajeBT.length());
			}
				
			finString = mensajeBT.indexOf('$');

			if(finString>0){
				String auxMensaje = new String (mensajeBT.substring(0,finString));
				mensajeBT =mensajeBT.substring(finString,mensajeBT.length());
				listadoStringMensajes.add(auxMensaje);
			}			
			
		}while(finString!=-1);	
	}
	
	public void gestionListaDeMensajesRecibido() {
		
		lecturaBloaquada=true;
		ArrayList<String> auxListadoStringMensajes = new ArrayList<String>(listadoStringMensajes);

		listadoStringMensajes.clear();
    	
		lecturaBloaquada=false;


		while (auxListadoStringMensajes.remove(null)) {
		}


		if(!auxListadoStringMensajes.isEmpty()){
			for (int i = 0; i < auxListadoStringMensajes.size(); ++i) {
				gestionMensajeRecibido(auxListadoStringMensajes.get(i));
			}
			auxListadoStringMensajes.clear();
		}
		
		//listadoStringMensajes.clear();
		
	}
	
	
	private void gestionMensajeRecibido(String mensaje){		
		
		String comando;
		
		int longitudMensaje= mensaje.length();
		
		if(mensaje.length()>2){
			
			comando=mensaje.substring(0,3);
			
			
			if(longitudMensaje>2){	
			
				  try{
				
			
			if(comando.equals("*BA")){
				  try{
					  	int nivelBattery = Integer.parseInt(mensaje.substring(3,longitudMensaje-1));
					  
					  	if (nivelBattery>=0 && nivelBattery<=100){
							setLevelBatery(Integer.toString(nivelBattery));
							getListadoMensajes().add(MainActivity.MENSAJE_RECIBIDO_BATERIA);
					  	}

						//setErrores(("Nivel Bateria " +  getBateria()));

				   	    Log.d("TAG *BA ", getLevelBatery());
				   	    
					  }
					  catch(NumberFormatException ex){
					    System.out.println("Error , Cadena");
					  }
				
			}else if(comando.equals("*TX")){
				
				  try{
						mensajeTexto = Integer.parseInt(mensaje.substring(3,longitudMensaje-1));
						getListadoMensajes().add(MainActivity.MENSAJE_RECIBIDO_TEXTO);
						  Log.d("TAG *TX ", " " + mensajeTexto);

					  }
					  catch(NumberFormatException ex){
					    System.out.println("No es un número, es una cadena de texto.");
					  }

			}else if(comando.equals("*VE")){
				  try{
						setVersionPromax12(mensaje.substring(3,longitudMensaje-1));


					  //setErrores(("Version promax " +  getVersionPromax12()));
						getListadoMensajes().add(MainActivity.MENSAJE_RECIBIDO_VERSION);
						
				   	    Log.d("TAG *VE ", " " + getVersionPromax12());
					  }
					  catch(NumberFormatException ex){
					    Log.e("TAG "," Catch Mensaje no procesado *VE " + mensaje + "Comando "+ comando);
					  }        
				
			}else if(comando.equals("*SC")){
				
				try{
					if (longitudMensaje == 12) {
						int posicion = Integer.parseInt(mensaje.substring(3,6));
						
						int dbm = Integer.parseInt(mensaje.substring(7,11));
						getListadoMensajes().add(MainActivity.MENSAJE_RECIBIDO_MESURA_SCAN);

						if (mensaje.substring(11, 12).equals("&")) {
							this.dBm = dbm;
							this.positionMarker = posicion;
							getListadoMensajes().add(MainActivity.MENSAJE_RECIBIDO_DBM_EQUIP);
						}
						
						valoresPromax12[posicion]=dbm;
						
						Log.d("TAG *SC ", " " + posicion + " Mesura "+  dbm + " long " + + longitudMensaje);
					}else {
						Log.d("TAG *SC No procesado", mensaje + " long " + longitudMensaje);
					}
					

					}
					catch(NumberFormatException ex){
					    Log.e("TAG "," Catch Mensaje no procesado *SC " + mensaje + "Comando "+ comando);
					}
			}else if(comando.equals("*SP")){
				
				try{
					if (longitudMensaje == 12) {
							int posicion = Integer.parseInt(mensaje.substring(3,6));
							
							int dbm = Integer.parseInt(mensaje.substring(7,11));

						getListadoMensajes().add(MainActivity.MENSAJE_RECIBIDO_MESURA_SPECTRUM);

						if (mensaje.substring(11, 12).equals("&")) {
							this.dBm = dbm;
							getListadoMensajes().add(MainActivity.MENSAJE_RECIBIDO_DBM_EQUIP);
						}
							
							valoresPromax12[posicion]=dbm;
							
							Log.d("TAG *SP ", " " + posicion + " Mesura "+  dbm + " long " + + longitudMensaje);
							
						}else {
						Log.d("TAG *SP No procesado", mensaje + " long " + longitudMensaje);
						}
					

					}
					catch(NumberFormatException ex){
					    Log.e("TAG "," Catch Mensaje no procesado *SC " + mensaje + "Comando "+ comando);
					}
				
			}else if(comando.equals("*FR")){
				try{
					if(longitudMensaje == 9){
						setFrequencyKhz( Integer.parseInt(mensaje.substring(3,9), 16));
						getListadoMensajes().add(MainActivity.MENSAJE_RECIBIDO_FREQUENCY);
						Log.d("TAG *FR ", "frequency " + getFrequencyKhz() + "Mensaje " + mensaje);
						
					}else {
						Log.d("TAG *FR ", "frequency "+ mensaje + " " + longitudMensaje);
					}


					}
					catch(NumberFormatException ex){
					    Log.e("TAG "," Catch Mensaje no procesado *FR " + mensaje + "Comando "+ comando);
					}

			} else if (comando.equals("*CO")) { //				"*CO%03d#%03d$"
				try {
					if (longitudMensaje == 10) {
						int posContelacioX = Integer.parseInt(mensaje.substring(3, 6));

						int posContelacioY = Integer.parseInt(mensaje.substring(7, 10));
						getListadoMensajes().add(MainActivity.MENSAJE_RECIBIDO_POINT_COSTELATION);

						//	Maximo mas alto de 128 es 53 y el mas bajo mayor de 128 es 202
						//	No hay puntos desde 55 hasta 201
						//	Tendriamos que llegar a 256 pero solo se llega 108
						// 256/108=2,37
						// se mutiplica por 48 y se divide por 20 y tenemos 2.40

						posContelacioX = (posContelacioX * 44) / 20; //48

						posContelacioY = (posContelacioY * 44) / 20; //48

						posContelacioX = (posContelacioX + 127);
						posContelacioY = (posContelacioY - 127) * (-1);
						if (posContelacioX < 256 && posContelacioX >= 0 && posContelacioY < 256 && posContelacioY >= 0) {
							arrayColisionesConstelacion[posContelacioX][posContelacioY]++;
						}


						Log.d("TAG *CO ", " " + posContelacioX + " posCcontelacioX " + posContelacioY + " posContelacioY " + " LOngMens " + longitudMensaje);
					} else {
						Log.d("TAG *CO ", mensaje + +longitudMensaje);
					}


				} catch (NumberFormatException ex) {
					Log.e("TAG ", " Catch Mensaje no procesado *SC " + mensaje + "Comando " + comando);
				}


            } else if (comando.equals("*ST")) { //
                try {
                    if (longitudMensaje == 18) {
                        int intervaloGuarda = Integer.parseInt(mensaje.substring(3, 6));
						int portadoras = Integer.parseInt(mensaje.substring(7, 10));
						int codeRate = Integer.parseInt(mensaje.substring(11, 14));
						int tipoModulaciónPortadoras = Integer.parseInt(mensaje.substring(15, 18));
						getListadoMensajes().add(MainActivity.MENSAJE_RECIBIDO_DADES_COSTELLATION);

						setIntervaloGuarda(intervaloGuarda);
						setPortadoras(portadoras);
						setCodeRate(codeRate);
						setTipoModulaciónPortadoras(tipoModulaciónPortadoras);

						Log.d("TAG *ST ", " IntervaloGuarda " + intervaloGuarda + " Portadoras " + portadoras + " codeRate " + codeRate + " tipoModulaciónPortadoras " + tipoModulaciónPortadoras + " LOngMens " + longitudMensaje);
					} else {
						Log.d("TAG *ST ", mensaje + " LOngMens " + longitudMensaje);
					}
				} catch (NumberFormatException ex) {
					Log.e("TAG ", " Catch Mensaje no procesado *SC " + mensaje + "Comando " + comando);
				}
			} else if (comando.equals("*BE")) {
				try {
					if (longitudMensaje == 14) {
						int preBer = Integer.parseInt(mensaje.substring(3, 8));
						int postBer = Integer.parseInt(mensaje.substring(9, 14));
						getListadoMensajes().add(MainActivity.MENSAJE_RECIBIDO_BERS_COSTELLATION);

						String auxPreBer = "CVER = " + ExtreuBER(preBer);
						String auxPosBer = "BVER = " + ExtreuBER(postBer);

						setPreBer(auxPreBer);
						setPostBer(auxPosBer);

						Log.d("TAG *BE ", " preBer " + preBer + " postBer " + postBer + " LOngMens " + longitudMensaje);
					} else {
						Log.d("TAG *BE ", mensaje + " LOngMens " + longitudMensaje);
					}
				} catch (NumberFormatException ex) {
					Log.e("TAG ", " Catch Mensaje no procesado *SC " + mensaje + "Comando " + comando);
				}
            } else if (comando.equals("*ME")) { //				"*CO%03d#%03d$"
                try {
                    if (longitudMensaje == 7) {

						int mer = Integer.parseInt(mensaje.substring(3, 6));
						getListadoMensajes().add(MainActivity.MENSAJE_RECIBIDO_MER_COSTELLATION);

						String auxMERr = "MER = " + mer + " dBuV";

                        setMer(auxMERr);

						Log.d("TAG *ME ", " MER " + mer + " LOngMens " + longitudMensaje);
					} else {
						Log.d("TAG *ME ", mensaje + " LOngMens " + longitudMensaje);
					}
                } catch (NumberFormatException ex) {
                    Log.e("TAG ", " Catch Mensaje no procesado *SC " + mensaje + "Comando " + comando);
                }
            } else if (comando.equals("*BR")) {

                try {
                    Log.d("TAG *BR ", "br " + mensaje);
					}
					catch(NumberFormatException ex){
					    Log.e("TAG "," Catch Mensaje no procesado *BR " + mensaje + "Comando "+ comando);
					}
			}else if(comando.equals("*BS")){
				try{
					Log.d("TAG *BS ", "bs " + mensaje);
					}
					catch(NumberFormatException ex){
					    Log.e("TAG "," Catch Mensaje no procesado *BS " + mensaje + "Comando "+ comando);
					}
			}else { 
				getListadoMensajes().add(MainActivity.MENSAJE_RECIBIDO_NOVALIDO);
				Log.e("TAG "," Mensaje no procesado " + mensaje + "Comando "+ comando);}
			  }
			  catch(NumberFormatException ex){
			    Log.e("TAG "," Catch Mensaje no procesado " + mensaje + "Comando "+ comando);
			  }

		}else {getListadoMensajes().add(MainActivity.MENSAJE_RECIBIDO_NOVALIDO);}


		}else {getListadoMensajes().add(MainActivity.MENSAJE_RECIBIDO_NOVALIDO);}

	}


	public String getLevelBatery() {
		return levelBatery;
	}


	public void setLevelBatery(String levelBatery) {
		this.levelBatery = levelBatery;
	}

	
	public ArrayList<Integer> getListadoMensajes() {
		return listadoMensajes;
	}


	public String getVersionPromax12() {
		return versionPromax12;
	}


	public void setVersionPromax12(String versionPromax12) {
		this.versionPromax12 = versionPromax12;
	}


	public int getFrequencyKhz() {
		return frequencyKhz;
	}


	public void setFrequencyKhz(int frequencyKhz) {
		this.frequencyKhz = frequencyKhz;
	}


	public int[] getValoresPromax12() {
		// TODO Auto-generated method stub
		return valoresPromax12;
	}


	public int getReferenLevel() {
		return referenLevel;
	}

	public void setReferenLevel(int referenLevel) {
		this.referenLevel = referenLevel;
	}


	public int getAmplitud() {
		return amplitud;
	}


	public void setAmplitud(int amplitud) {
		this.amplitud = amplitud;
	}


	public int getSpam() {
		return spam;
	}


	public void setSpam(int spam) {
		this.spam = spam;
	}


	public int getPantalla() {
		return pantalla;
	}


	public void setPantalla(int pantalla) {
		this.pantalla = pantalla;
	}


	public Boolean getInicializadoPromax12() {
		return inicializadoPromax12;
	}


	public void setInicializadoPromax12(Boolean inicializadoPromax12) {
		this.inicializadoPromax12 = inicializadoPromax12;
	}

	public void inicializarArrayColisionesConstelacion() {

		for (int i = 0; i < 255; i++) {
			for (int j = 0; j < 255; j++) {
				arrayColisionesConstelacion[i][j] = 0;
			}

		}
	}

	public void inicializarArrayPromax12() {

		for (int i = 0; i < 500; i++) {
			valoresPromax12[i] = 0;
		}
	}


	public int getIntervaloGuarda() {
		return intervaloGuarda;
	}

	public void setIntervaloGuarda(int intervaloGuarda) {
		this.intervaloGuarda = intervaloGuarda;
	}

	public int getPortadoras() {
		return portadoras;
	}

	public void setPortadoras(int portadoras) {
		this.portadoras = portadoras;
	}

	public int getCodeRate() {
		return codeRate;
	}

	public void setCodeRate(int codeRate) {
		this.codeRate = codeRate;
	}

	public int getTipoModulaciónPortadoras() {
		return tipoModulaciónPortadoras;
	}

	public void setTipoModulaciónPortadoras(int tipoModulaciónPortadoras) {
		this.tipoModulaciónPortadoras = tipoModulaciónPortadoras;
	}

	public String getPreBer() {
		return preBer;
	}

	public void setPreBer(String preBer) {
		this.preBer = preBer;
	}

    public String getMer() {
        return mer;
    }

    public void setMer(String mer) {
        this.mer = mer;
    }

	public String getPostBer() {
		return postBer;
	}

	public void setPostBer(String postBer) {
		this.postBer = postBer;
	}

	public String ExtreuBER(int valor) {
		String text = "";

		if ((valor & 0x0080) == 0x0080) text = text + "<"; //UNDERRANGE;
		if ((valor & 0x0040) == 0x0040) text = text + ">"; //OVERRANGE;

		float mantisa = (valor & 0xFF00) >> 8;
		text = text + (mantisa / 10);

		int exponent = valor & 0x3F;

		text = text + "E-" + exponent;

		return text;
	}

	public String getStringIntervaloGuarda() {
		String text = "Guarda = ";

		switch (getIntervaloGuarda()) {
			case eGUARD_1_32:
                text = text + "1/32";
                break;
            case eGUARD_1_16:
                text = text + "1/16";
                break;
            case eGUARD_1_8:
                text = text + "1/8 ";
                break;
            case eGUARD_1_4:
            default:
                text = text + "1/4 ";
                break;
        }
        return text;
	}

	public String getStringPortadoras() {
		String text = "Portadoras = ";
		switch (getPortadoras()) { //Debugged.
			case eBW_6MHz:
				text = text + "6K";
				break;   // ALL STANDARDS
			case eBW_7MHz:
				text = text + "7K";
				break;   // ALL STANDARDS
			case eBW_8MHz: //Debugged.
			default:
				text = text + "8K";
				break;   // ALL STANDARDS
		}
		return text;
	}


	public String getStringCodeRate() {
		String text = "Code Rate = ";
		switch (getCodeRate()) {
			case eCR_1_2:
                text = text + "1/2";
                break;
            case eCR_2_3:
                text = text + "2/3";
                break;
            case eCR_3_4:
                text = text + "3/4";
                break;
            case eCR_4_5:
                text = text + "4/5";
                break;
            case eCR_5_6:
                text = text + "5/6";
                break;
            case eCR_6_7:
                text = text + "6/7";
                break;
            case eCR_7_8:
            default:
                text = text + "7/8";
                break;
            // RPS: 9/2/2007 -> Nous Code Rates per DVBS2.
            case eCR_1_4:
                text = text + "1/4";
                break;
            case eCR_1_3:
                text = text + "1/3";
                break;
            case eCR_2_5:
                text = text + "1/5";
                break;
            case eCR_3_5:
                text = text + "3/5";
                break;
            case eCR_8_9:
                text = text + "8/9";
                break;
            case eCR_9_10:
                text = text + "9/10";
                break;
        }
        return text;
	}

	public String getStringTipoModulaciónPortadoras() {
		String text = "Modulacion = ";
		switch (getTipoModulaciónPortadoras()) { //Debugged.
			case eCONSTELLATION_QPSK:
				text = text + "QPSK";
				break;
			case eCONSTELLATION_16QAM:
				text = text + "QAM16";
				break;
			case eCONSTELLATION_64QAM:
			default:
				text = text + "QAM64";
				break;
		}
		return text;
	}

	public Canalizacion getCanalesCCIR() {
		return canalesCCIR;
	}

	public void setCanalesCCIR(Canalizacion canalesCCIR) {
		this.canalesCCIR = canalesCCIR;
	}


	public int getFrequencyKhzMim() {
		return frequencyKhzMim;
	}

    public void setFrequencyKhzMim(int frequencyKhzMim) {
        this.frequencyKhzMim = frequencyKhzMim;
    }

    public int getFrequencyKhzMax() {
        return frequencyKhzMax;
    }

    public void setFrequencyKhzMax(int frequencyKhzMax) {
        this.frequencyKhzMax = frequencyKhzMax;
    }

	public int getdBm() {
		return dBm;
	}

	public int getPositionMarker() {
		return positionMarker;
	}


    public float calculoRecta(int pos) {
        int divisiones = 110;
        float indice = 0;

        if (pos < canalesCCIR.getCanalizacion().size()) {
            int frequencyKhz = canalesCCIR.getCanalizacion().get(pos).getFrequencyChannel();

            if (frequencyKhz <= getFrequencyKhzMax() && frequencyKhz >= getFrequencyKhzMim()) {

                float divisor = getFrequencyKhzMax() - getFrequencyKhzMim();
                indice = (divisiones * frequencyKhz / divisor) - (divisiones * getFrequencyKhzMim() / divisor);
            }
        }
        return indice;
    }

	public String getStringSpam() {

		String s_spam;
		switch (getSpam()) {

			case 0:
				s_spam = "SPAN: 100 MHz";
				break;
			case 1:
				s_spam = "SPAN: 50 MHz";
				break;
			case 2:
				s_spam = "SPAN: 30 MHz";
				break;
			case 3:
				s_spam = "SPAN: 15 MHz";
				break;
			case 4:
				s_spam = "SPAN: 5 MHz";
				break;
			case 5:
				s_spam = "SPAN: 1 MHz";
				break;

			default:
				s_spam = "SPAN: FULL";
				break;
		}
		return s_spam;
	}
}
